#include "Teste.h"

CommSerial A(0, 115200);

// Define as variáveis a serem enviadas para o sistema
// Define o número de variáveis
uint8_t n_var = 25;
// Define o vetor de 16bits
uint8_t msg_var[25];

int led = 13;

void setup() {
	// initialize serial communication at 9600 bits per second:
	A.baud(115200);
	//Serial.begin(115200);
	pinMode(led, OUTPUT);
	digitalWrite(led, LOW);
}

// the loop routine runs over and over again forever:
void loop() {


	while (Serial.available() <= 0) {

	}

	// Ao sair do loop, ele lê a cariavel de comando
	uint8_t com = A.recebeSerial();

	if (com == 17){
		digitalWrite(led, HIGH);
		//Serial.write(com);
		// Cabeçalho 4201
		uint16_t cab = 4201;
		msg_var[0] = cab & 0xff;
		msg_var[1] = (cab >> 8);

		// MPX
		//uint16_t aux_MPX = random(0,1024);
		uint16_t aux_MPX = 200;
		msg_var[2] = aux_MPX & 0xff;//aux_MPX & 0xff;
		msg_var[3] = (aux_MPX >> 8);


		// MAP
		//uint16_t aux_MAP = random(0,1024);
		uint16_t aux_MAP = 800;
		msg_var[4] = aux_MAP & 0xff;
		msg_var[5] = (aux_MAP >> 8);

		// TPS
		uint16_t aux_TPS = random(0,1024);
		msg_var[6] = aux_TPS & 0xff;
		msg_var[7] = (aux_TPS >> 8);

		// O2A
		uint16_t aux_O2A = random(0,1024);
		msg_var[8] = aux_O2A & 0xff;
		msg_var[9] = (aux_O2A >> 8);

		// O2B
		uint16_t aux_O2B = random(0,1024);
		msg_var[10] = aux_O2B & 0xff;
		msg_var[11] = (aux_O2B >> 8);

		// MAT
		uint16_t aux_MAT = random(0,1024);
		msg_var[12] = aux_MAT & 0xff;
		msg_var[13] = (aux_MAT >> 8);

		// CLT
		uint16_t aux_CLT = random(0,1024);
		msg_var[14] = aux_CLT & 0xff;
		msg_var[15] = (aux_CLT >> 8);

		// AD01
		uint16_t aux_AD01 = random(0,1024);
		msg_var[16] = aux_AD01 & 0xff;
		msg_var[17] = (aux_AD01 >> 8);

		// AD02
		uint16_t aux_AD02 = random(0,1024);
		msg_var[18] = aux_AD02 & 0xff;
		msg_var[19] = (aux_AD02 >> 8);

		// Rotacao
		uint16_t aux_rot = random(0,1024);
		msg_var[20] = aux_rot & 0xff;
		msg_var[21] = (aux_rot >> 8);

		// Temp Processador
		uint8_t tmp_cpu = random(0,255);
		msg_var[22] = tmp_cpu;

		// Tensao da bateria
		uint8_t ten_bat = 77;//random(0,255);
		msg_var[23] = ten_bat;

		// CRC8
		msg_var[24] = OneWire::crc8(msg_var, 24);

		A.escreveSerial(msg_var, n_var);
	}

}
