/*
 * CommSerial.cpp
 *
 *  Created on: 21 de ago de 2015
 *      Author: Remote
 */

#include "CommSerial.h"

// Função cria a variável da classe definindo o baud
CommSerial::CommSerial(uint8_t serial,long baud):
_baud(baud),
_serial(serial){

	// Inicia a serial
/*	switch (_serial){
	case 1:
		Serial1.begin(_baud);
		break;
	case 2:
		Serial2.begin(_baud);
		break;
	case 3:
		Serial3.begin(_baud);
		break;
	default:
		// Caso a serial seja a 0 inicia no hardware
		Serial.begin(_baud);
		pinMode(31, OUTPUT);
		digitalWrite(13, HIGH);
		break;
	}*/

}

// Função pode modificar o baud da classe
void CommSerial::baud(long baud){
	_baud = baud;
	Serial.begin(_baud);
	pinMode(31, OUTPUT);
	digitalWrite(13, HIGH);
}

// Retorna o baud rate da serial
long CommSerial::baud(){
	return _baud;
}

// Função pode modificar qual serial está sendo usada
void CommSerial::serial(uint8_t serial){
	_serial = serial;
}

void CommSerial::escreveSerial(uint8_t* msg, uint8_t len){
	switch (_serial){
	case 1:
		Serial1.write(msg, len);
		break;
	default:
		Serial.write(msg, len);
		break;
	}
}

uint8_t CommSerial::recebeSerial(){

	uint8_t answer;

	switch (_serial){
	case 1:
		answer = Serial1.read();
		break;
	default:
		answer = Serial.read();
		break;
	}
	return answer;
}


